#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...

# task: use the perl find module to check all files in a
# directory tree for some property, and return a list...

my $ANYTEXTFILE = 1; # *** set find not only HTML files, 
                     # *** new 16 feb 2002

use File::Find;
my %filelist; # whoa, a global var...

sub xprint {
#  print "" . $_[0] . ""; # redefine to no-op to avoid printing
                          # of the file list...
}

sub addhtml { # add to filelist if name ends in htm(l)
              # *** refined for week 6
  my $who = $File::Find::name;
  if (-d $who) { print STDERR "Directory $who\n"; }
  elsif (($ANYTEXTFILE) ||
         ($who =~ /[.][sp]?htm[l]?$/)) { # file name ok?
    if ((-r $who) && (-T $who)) { # readable text file?

      if (($who =~ /pdf$/i) || ($who =~ /ps$/i) ||
          ($who =~ /gz$/i)  || ($who =~ /zip$/i) ||
          ($who =~ /gif$/i) || ($who =~ /jpg$/i) ||
          ($who =~ /mp3$/i) || ($who =~ /[,;]/) ) {
        print STDERR "I do not dare to add a file called: <"
          .   "$who>\n";
      } else {
        $filelist{$who} = 1;
      }

    } else {
      print STDERR "file gone???: <$who>\n" unless (-e $who);

      if ( (! $who =~ /gz/i) &&
           (($who =~ /htm/i) || ($who =~ /txt/i)) ) {
        print STDERR "no text file: <$who>\n" unless (-T $who);
      }

      print STDERR "cannot read <$who>\n" unless (-r $who);
      # open(FOO,"<$who") || ... "yuck <$who> $!\n"; close(FOO);
      # $! is the current errno or errname
    }
  } else {
    # print STDERR "not *.[sp]?htm[l]?: $who\n";
  }
}


sub collecthtmlfiles { # make a list of HTML files in path arg
  my $PFAD;
  $PFAD = $_[0]; # get the where...
  %filelist = ();
  my $count = 0;

  find(\&addhtml, $PFAD);

  if ($ANYTEXTFILE) {
    print "Text files (incl. HTML) found:\n";
  } else {
    print "HTML files found:\n";
  }

  for my $thekey (sort keys %filelist) {
    &xprint("$thekey\n"); $count++;
    if ($thekey =~ /\011/) { # *** week 6: colon <-> DOS, so tab
      print STDERR "Illegal TAB in filename, skipping "
        . "further processing of\n<$thekey>\n";
      $filelist{$thekey} = undef;
    }
  };
  print "$count files found.\n\n";
  return (join("\011",keys %filelist)); # *** week 6: TAB as sep
}

return 1; # make require succeed

