#!/usr/bin/perl -w
# -T can only be given on the command line (taint checking)
use strict; # homework by Eric Auer...
# *** addition in week 6: read number of indexed files from
# *** the first line if that line is [0-9]+

use vars qw/%H/; # could be a list: make those very global

my $SHOWINDEX = 0; # set to 1 to print the hash (big...)
my %H;           # the main hash

my $numoffiles = 1; # *** for week 6 - must be nonzero.


sub readindex {
  unless (open(IFILE,"gzip -dc <index.txt.gz|")) {
    # surpising syntax, he?
    print STDERR "compressed index.txt.gz not found or\n"
      .   "gzip not installed, trying index.txt\n";
    open (IFILE,"<index.txt") || die "Cannot read index.txt\n";
  } # *** compressed index.txt is new in week 6

  my @ilines = <IFILE>;

  close(IFILE);

  die "Empty index.txt(.gz)\n" if (!defined $ilines[0]);

  $numoffiles = $ilines[0] if ($ilines[0] =~ /^[0-9]*/);
  # *** that was for week 6

  my $terms = 0;
  my $iline;
  foreach $iline (@ilines) {
    unless ($iline =~ /;.*,/) { next; } # skip too weird lines
    chomp $iline; # kind of important...
    $terms++;
    $iline =~ tr/\007/:/; # make our special char user-friendly
    my $iword;
    my @iwhere;
    ($iword,@iwhere) = split(/;/,$iline); # first parse step
    my $iwhere2;
    foreach $iwhere2 (@iwhere) {
      my $ifile;
      my @iposn;
      ($ifile,@iposn) = split(/,/,$iwhere2); # second parse step
      $H{$iword}->{$ifile} = join(",",@iposn); # the big hash!
    }
  }
  return $terms;
}


sub showindex {
  foreach my $oneword (sort keys %H) {
    printf "\n%20s: ", $oneword;
    foreach my $item (sort keys %{$H{$oneword}}) {
      print "<\"$item\"," . $H{$oneword}->{$item} . "> ";
    }
  }
}


sub reftoindex {
  return \%H;
}


sub filesinindex { # *** very simple extension for week 6
  return $numoffiles;
}


print "loading index...\n";
print "" . &readindex() . " terms loaded\n";
if ($SHOWINDEX == 1) { &showindex }

return 1; # if we were "required", tell that we succeeded

